searchData={"items":[{"type":"module","title":"HNSWLib.BFIndex","doc":"Documentation for `HNSWLib.BFIndex`.","ref":"HNSWLib.BFIndex.html"},{"type":"function","title":"HNSWLib.BFIndex.add_items/3","doc":"Add items to the index.\n\n###","ref":"HNSWLib.BFIndex.html#add_items/3"},{"type":"function","title":"Positional Parameters - HNSWLib.BFIndex.add_items/3","doc":"- *data*: `Nx.Tensor.t()`.\n\n  Data to add to the index.\n\n###","ref":"HNSWLib.BFIndex.html#add_items/3-positional-parameters"},{"type":"function","title":"Keyword Parameters - HNSWLib.BFIndex.add_items/3","doc":"- *ids*: `Nx.Tensor.t() | [non_neg_integer()] | nil`.\n\n  IDs to assign to the data.\n\n  If `nil`, IDs will be assigned sequentially starting from 0.\n\n  Defaults to `nil`.","ref":"HNSWLib.BFIndex.html#add_items/3-keyword-parameters"},{"type":"function","title":"HNSWLib.BFIndex.delete_vector/2","doc":"Delete vectors with the given labels from the index.","ref":"HNSWLib.BFIndex.html#delete_vector/2"},{"type":"function","title":"HNSWLib.BFIndex.knn_query/3","doc":"Query the index with a single vector or a list of vectors.\n\n###","ref":"HNSWLib.BFIndex.html#knn_query/3"},{"type":"function","title":"Positional Parameters - HNSWLib.BFIndex.knn_query/3","doc":"- *query*: `Nx.Tensor.t() | binary() | [binary()]`.\n\n  A vector or a list of vectors to query.\n\n  If *query* is a list of vectors, the vectors must be of the same dimension.\n\n###","ref":"HNSWLib.BFIndex.html#knn_query/3-positional-parameters"},{"type":"function","title":"Keyword Paramters - HNSWLib.BFIndex.knn_query/3","doc":"- *k*: `pos_integer()`.\n\n  Number of nearest neighbors to return.","ref":"HNSWLib.BFIndex.html#knn_query/3-keyword-paramters"},{"type":"function","title":"HNSWLib.BFIndex.load_index/4","doc":"Load index from disk.\n\n###","ref":"HNSWLib.BFIndex.html#load_index/4"},{"type":"function","title":"Positional Parameters - HNSWLib.BFIndex.load_index/4","doc":"- *space*: `:cosine` | `:ip` | `:l2`.\n\n  An atom that indicates the vector space. Valid values are\n\n    - `:cosine`, cosine space\n    - `:ip`, inner product space\n    - `:l2`, L2 space\n\n- *dim*: `non_neg_integer()`.\n\n  Number of dimensions for each vector.\n\n- *path*: `Path.t()`.\n\n  Path to load the index from.\n\n###","ref":"HNSWLib.BFIndex.html#load_index/4-positional-parameters"},{"type":"function","title":"Keyword Parameters - HNSWLib.BFIndex.load_index/4","doc":"- *max_elements*: `non_neg_integer()`.\n\n  Maximum number of elements to load from the index.\n\n  If set to 0, all elements will be loaded.\n\n  Defaults to 0.","ref":"HNSWLib.BFIndex.html#load_index/4-keyword-parameters"},{"type":"function","title":"HNSWLib.BFIndex.new/3","doc":"Construct a new BFIndex\n\n###","ref":"HNSWLib.BFIndex.html#new/3"},{"type":"function","title":"Positional Parameters - HNSWLib.BFIndex.new/3","doc":"- *space*: `:cosine` | `:ip` | `:l2`.\n\n  An atom that indicates the vector space. Valid values are\n\n    - `:cosine`, cosine space\n    - `:ip`, inner product space\n    - `:l2`, L2 space\n\n- *dim*: `non_neg_integer()`.\n\n  Number of dimensions for each vector.\n\n- *max_elements*: `non_neg_integer()`.\n\n  Number of maximum elements.","ref":"HNSWLib.BFIndex.html#new/3-positional-parameters"},{"type":"function","title":"HNSWLib.BFIndex.save_index/2","doc":"Save current index to disk.\n\n###","ref":"HNSWLib.BFIndex.html#save_index/2"},{"type":"function","title":"Positional Parameters - HNSWLib.BFIndex.save_index/2","doc":"- *path*: `Path.t()`.\n\n  Path to save the index to.","ref":"HNSWLib.BFIndex.html#save_index/2-positional-parameters"},{"type":"module","title":"HNSWLib.Index","doc":"Documentation for `HNSWLib.Index`.","ref":"HNSWLib.Index.html"},{"type":"function","title":"HNSWLib.Index.add_items/3","doc":"Add items to the index.\n\n###","ref":"HNSWLib.Index.html#add_items/3"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.add_items/3","doc":"- *data*: `Nx.Tensor.t()`.\n\n  Data to add to the index.\n\n###","ref":"HNSWLib.Index.html#add_items/3-positional-parameters"},{"type":"function","title":"Keyword Parameters - HNSWLib.Index.add_items/3","doc":"- *ids*: `Nx.Tensor.t() | [non_neg_integer()] | nil`.\n\n  IDs to assign to the data.\n\n  If `nil`, IDs will be assigned sequentially starting from 0.\n\n  Defaults to `nil`.\n\n- *num_threads*: `integer()`.\n\n  Number of threads to use.\n\n  If set to `-1`, the number of threads will be automatically determined.\n\n  Defaults to `-1`.\n\n- *replace_deleted*: `boolean()`.\n\n  Whether to replace deleted items.\n\n  Defaults to `false`.","ref":"HNSWLib.Index.html#add_items/3-keyword-parameters"},{"type":"function","title":"HNSWLib.Index.get_current_count/1","doc":"Get the current number of elements in the index.","ref":"HNSWLib.Index.html#get_current_count/1"},{"type":"function","title":"HNSWLib.Index.get_ef/1","doc":"Get the ef parameter.","ref":"HNSWLib.Index.html#get_ef/1"},{"type":"function","title":"HNSWLib.Index.get_ef_construction/1","doc":"Get the ef_construction parameter.","ref":"HNSWLib.Index.html#get_ef_construction/1"},{"type":"function","title":"HNSWLib.Index.get_ids_list/1","doc":"Get a list of existing IDs in the index.","ref":"HNSWLib.Index.html#get_ids_list/1"},{"type":"function","title":"HNSWLib.Index.get_items/2","doc":"Retrieve items from the index using IDs.\n\n###","ref":"HNSWLib.Index.html#get_items/2"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.get_items/2","doc":"- *ids*: `Nx.Tensor.t() | [non_neg_integer()]`.\n\n  IDs to retrieve.","ref":"HNSWLib.Index.html#get_items/2-positional-parameters"},{"type":"function","title":"HNSWLib.Index.get_m/1","doc":"Get the M parameter.","ref":"HNSWLib.Index.html#get_m/1"},{"type":"function","title":"HNSWLib.Index.get_max_elements/1","doc":"Get the maximum number of elements the index can hold.","ref":"HNSWLib.Index.html#get_max_elements/1"},{"type":"function","title":"HNSWLib.Index.get_num_threads/1","doc":"Get the number of threads to use.","ref":"HNSWLib.Index.html#get_num_threads/1"},{"type":"function","title":"HNSWLib.Index.knn_query/3","doc":"Query the index with a single vector or a list of vectors.\n\n###","ref":"HNSWLib.Index.html#knn_query/3"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.knn_query/3","doc":"- *query*: `Nx.Tensor.t() | binary() | [binary()]`.\n\n  A vector or a list of vectors to query.\n\n  If *query* is a list of vectors, the vectors must be of the same dimension.\n\n###","ref":"HNSWLib.Index.html#knn_query/3-positional-parameters"},{"type":"function","title":"Keyword Paramters - HNSWLib.Index.knn_query/3","doc":"- *k*: `pos_integer()`.\n\n  Number of nearest neighbors to return.\n\n- *num_threads*: `integer()`.\n\n  Number of threads to use.","ref":"HNSWLib.Index.html#knn_query/3-keyword-paramters"},{"type":"function","title":"HNSWLib.Index.load_index/4","doc":"Load index from disk.\n\n###","ref":"HNSWLib.Index.html#load_index/4"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.load_index/4","doc":"- *space*: `:cosine` | `:ip` | `:l2`.\n\n  An atom that indicates the vector space. Valid values are\n\n    - `:cosine`, cosine space\n    - `:ip`, inner product space\n    - `:l2`, L2 space\n\n- *dim*: `non_neg_integer()`.\n\n  Number of dimensions for each vector.\n\n- *path*: `Path.t()`.\n\n  Path to load the index from.\n\n###","ref":"HNSWLib.Index.html#load_index/4-positional-parameters"},{"type":"function","title":"Keyword Parameters - HNSWLib.Index.load_index/4","doc":"- *max_elements*: `non_neg_integer()`.\n\n  Maximum number of elements to load from the index.\n  If set to 0, all elements will be loaded.\n  Default: 0.\n\n- *allow_replace_deleted*: `boolean()`.","ref":"HNSWLib.Index.html#load_index/4-keyword-parameters"},{"type":"function","title":"HNSWLib.Index.mark_deleted/2","doc":"Mark a label as deleted.\n\n###","ref":"HNSWLib.Index.html#mark_deleted/2"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.mark_deleted/2","doc":"- *label*: `non_neg_integer()`.\n\n  Label to mark as deleted.","ref":"HNSWLib.Index.html#mark_deleted/2-positional-parameters"},{"type":"function","title":"HNSWLib.Index.new/4","doc":"Construct a new Index\n\n###","ref":"HNSWLib.Index.html#new/4"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.new/4","doc":"- *space*: `:cosine` | `:ip` | `:l2`.\n\n  An atom that indicates the vector space. Valid values are\n\n    - `:cosine`, cosine space\n    - `:ip`, inner product space\n    - `:l2`, L2 space\n\n- *dim*: `non_neg_integer()`.\n\n  Number of dimensions for each vector.\n\n- *max_elements*: `non_neg_integer()`.\n\n  Number of maximum elements.\n\n###","ref":"HNSWLib.Index.html#new/4-positional-parameters"},{"type":"function","title":"Keyword Paramters - HNSWLib.Index.new/4","doc":"- *m*: `non_neg_integer()`.\n\n  `M` is tightly connected with internal dimensionality of the data\n  strongly affects the memory consumption\n\n- *ef_construction*: `non_neg_integer()`.\n\n  controls index search speed/build speed tradeoff\n\n- *random_seed*: `non_neg_integer()`.\n- *allow_replace_deleted*: `boolean()`.","ref":"HNSWLib.Index.html#new/4-keyword-paramters"},{"type":"function","title":"HNSWLib.Index.resize_index/2","doc":"Resize the index.\n\n###","ref":"HNSWLib.Index.html#resize_index/2"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.resize_index/2","doc":"- *new_size*: `non_neg_integer()`.\n\n  New size of the index.","ref":"HNSWLib.Index.html#resize_index/2-positional-parameters"},{"type":"function","title":"HNSWLib.Index.save_index/2","doc":"Save current index to disk.\n\n###","ref":"HNSWLib.Index.html#save_index/2"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.save_index/2","doc":"- *path*: `Path.t()`.\n\n  Path to save the index to.","ref":"HNSWLib.Index.html#save_index/2-positional-parameters"},{"type":"function","title":"HNSWLib.Index.set_ef/2","doc":"Set the ef parameter.","ref":"HNSWLib.Index.html#set_ef/2"},{"type":"function","title":"HNSWLib.Index.set_num_threads/2","doc":"Set the number of threads to use.","ref":"HNSWLib.Index.html#set_num_threads/2"},{"type":"function","title":"HNSWLib.Index.unmark_deleted/2","doc":"Unmark a label as deleted.\n\n###","ref":"HNSWLib.Index.html#unmark_deleted/2"},{"type":"function","title":"Positional Parameters - HNSWLib.Index.unmark_deleted/2","doc":"- *label*: `non_neg_integer()`.\n\n  Label to unmark as deleted.","ref":"HNSWLib.Index.html#unmark_deleted/2-positional-parameters"}],"content_type":"text/markdown"}